<?php
//--------------------------------------------------------------------
// *** Pop Rank ***
// LAST UPDATE: 2011/05/02
// Version    : 1.82
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// poprank.php
//
//--------------------------------------------------------------------

require BLOGN_MODDIR."poprank/function.php";

$blogn_mod_poprank_inifile = BLOGN_MODDIR."poprank/config.ini";
$blogn_mod_poprank_ini = parse_ini_file($blogn_mod_poprank_inifile);

$blogn_mod_poprank_popfile = BLOGN_MODDIR.'poprank/log/popular.log';

// 指定記事表示の時にカウント
switch ($blogn_view_mode) {
	case "e":
		$blogn_mod_poprank_ipaddr = $blogn_server_remode_addr;

		// ログファイル名
		$blogn_mod_poprank_log[0] = BLOGN_MODDIR.'poprank/log/'.date("Ymd").'.log';
		$blogn_mod_poprank_log[1] = BLOGN_MODDIR.'poprank/log/'.date("Ymd", blogn_mod_poprank_get_day(1)).'.log';
		$blogn_mod_poprank_log[2] = BLOGN_MODDIR.'poprank/log/'.date("Ymd", blogn_mod_poprank_get_day(2)).'.log';
		$blogn_mod_poprank_log[3] = BLOGN_MODDIR.'poprank/log/'.date("Ymd", blogn_mod_poprank_get_day(3)).'.log';
		$blogn_mod_poprank_log[4] = BLOGN_MODDIR.'poprank/log/'.date("Ymd", blogn_mod_poprank_get_day(4)).'.log';
		$blogn_mod_poprank_log[5] = BLOGN_MODDIR.'poprank/log/'.date("Ymd", blogn_mod_poprank_get_day(5)).'.log';
		$blogn_mod_poprank_log[6] = BLOGN_MODDIR.'poprank/log/'.date("Ymd", blogn_mod_poprank_get_day(6)).'.log';
		$blogn_mod_poprank_log[7] = BLOGN_MODDIR.'poprank/log/'.date("Ymd", blogn_mod_poprank_get_day(7)).'.log';
		$blogn_mod_poprank_log[8] = BLOGN_MODDIR.'poprank/log/'.date("Ymd", blogn_mod_poprank_get_day(8)).'.log';

		// 古いログを削除＆集計データ作成
		if (file_exists($blogn_mod_poprank_log[8])) {
			unlink($blogn_mod_poprank_log[8]);
	
			switch ($blogn_mod_poprank_ini["days"]) {
				case "7":
					$blogn_mod_poprank_logs = array_merge(file($blogn_mod_poprank_log[1]), file($blogn_mod_poprank_log[2]), file($blogn_mod_poprank_log[3]), file($blogn_mod_poprank_log[4]), file($blogn_mod_poprank_log[5]), file($blogn_mod_poprank_log[6]), file($blogn_mod_poprank_log[7]));
					break;
				case "6":
					$blogn_mod_poprank_logs = array_merge(file($blogn_mod_poprank_log[1]), file($blogn_mod_poprank_log[2]), file($blogn_mod_poprank_log[3]), file($blogn_mod_poprank_log[4]), file($blogn_mod_poprank_log[5]), file($blogn_mod_poprank_log[6]));
					break;
				case "5":
					$blogn_mod_poprank_logs = array_merge(file($blogn_mod_poprank_log[1]), file($blogn_mod_poprank_log[2]), file($blogn_mod_poprank_log[3]), file($blogn_mod_poprank_log[4]), file($blogn_mod_poprank_log[5]));
					break;
				case "4":
					$blogn_mod_poprank_logs = array_merge(file($blogn_mod_poprank_log[1]), file($blogn_mod_poprank_log[2]), file($blogn_mod_poprank_log[3]), file($blogn_mod_poprank_log[4]));
					break;
				case "3":
					$blogn_mod_poprank_logs = array_merge(file($blogn_mod_poprank_log[1]), file($blogn_mod_poprank_log[2]), file($blogn_mod_poprank_log[3]));
					break;
				case "2":
					$blogn_mod_poprank_logs = array_merge(file($blogn_mod_poprank_log[1]), file($blogn_mod_poprank_log[2]));
					break;
				case "1":
					$blogn_mod_poprank_logs = file($blogn_mod_poprank_log[1]);
					break;
				default:
					break;
			}
	
			$blogn_mod_poprank_data = @array_count_values($blogn_mod_poprank_logs);
			@arsort($blogn_mod_poprank_data);
			$blogn_mod_poprank_data = array_slice($blogn_mod_poprank_data, 0, 50);
			$blogn_mod_poprank_data_for_popfile = "";
			foreach($blogn_mod_poprank_data as $key => $value) {
				$log = blogn_mod_db_log_load_for_editor(rtrim($key));
				if ($log[0]) {
					$blogn_mod_poprank_data_title = ($log[1]["title"]) ? str_replace(",", "&#44;", $log[1]["title"]) : blogn_mod_poprank_convert_date($log[1]["date"]);
					$blogn_mod_poprank_data_for_popfile .= rtrim($key).','.rtrim($value).','.$blogn_mod_poprank_data_title.",\n";
				}
			}

			$fp = @fopen($blogn_mod_poprank_popfile, "w");
			flock($fp, LOCK_EX);
			fputs($fp, $blogn_mod_poprank_data_for_popfile);
			flock($fp, LOCK_UN);
			fclose($fp);

			// 過去31日間の記録集計
			$blogn_mod_poprank_pv = @file($blogn_mod_poprank_log[1]);
			$blogn_mod_poprank_pv = count($blogn_mod_poprank_pv);
			$blogn_mod_poprank_hstfile = BLOGN_MODDIR."poprank/log/month.cgi";
			$blogn_mod_poprank_history = @file($blogn_mod_poprank_hstfile);
			$blogn_mod_poprank_pvs = "$blogn_mod_poprank_pv\n";
			for ($i = 0; $i < 30; $i++) {
				$blogn_mod_poprank_pvs .= $blogn_mod_poprank_history[$i];
			}
			$fp = @fopen($blogn_mod_poprank_hstfile, "w");
			flock($fp, LOCK_EX);
			fputs($fp, $blogn_mod_poprank_pvs);
			flock($fp, LOCK_UN);
			fclose($fp);
		}
	

		// PVをカウント
		if ($blogn_get_e) {
			// IPによる除外機能
			if ($blogn_mod_poprank_ini["author"] == "auon" && strlen($blogn_mod_poprank_ini["ip"]) > 0 ) {
				$blogn_mod_poprank_ips = str_replace(".", "dot", $blogn_mod_poprank_ini["ip"]);
				$blogn_mod_poprank_ip_list = explode("/", $blogn_mod_poprank_ips);
				if (is_array($blogn_mod_poprank_ip_list)) {
					foreach ($blogn_mod_poprank_ip_list as $blogn_mod_poprank_ip_nocount) {
						$blogn_mod_poprank_ipaddr = str_replace(".", "dot", $blogn_mod_poprank_ipaddr);
						if (preg_match("/^$blogn_mod_poprank_ip_nocount/", $blogn_mod_poprank_ipaddr)) {
							$blogn_mod_poprank_ip_check = true;
						}
					}
					if ($blogn_mod_poprank_ip_check) {
						$blogn_mod_poprank_eid = "";
					} else {
						$blogn_mod_poprank_eid = "$blogn_get_e\n";
					}
				}
			} else {
				$blogn_mod_poprank_eid = "$blogn_get_e\n";
			}
			$fp = @fopen($blogn_mod_poprank_log[0], "a");
			flock($fp, LOCK_EX);
			fputs($fp, $blogn_mod_poprank_eid);
			flock($fp, LOCK_UN);
			fclose($fp);
		}
		break;

	default:
		break;
}

// スキンに表示
if (strpos($blogn_skin, "{POPRANK}")) {
	if (file_exists($blogn_mod_poprank_popfile)) {
		$blogn_mod_poprank_data_popfile = file($blogn_mod_poprank_popfile);
		$blogn_mod_poprank_output = "<ol id=\"poprank\">\n";
		for ($i = 0; $i < $blogn_mod_poprank_ini["rank"]; $i++) {
			list($blogn_mod_poprank_pop["id"], $blogn_mod_poprank_pop["count"], $blogn_mod_poprank_pop["title"]) = explode(",", $blogn_mod_poprank_data_popfile[$i]);
			$blogn_mod_poprank_output .= '<li><a href="index.php?e='.$blogn_mod_poprank_pop["id"].'">'.$blogn_mod_poprank_pop["title"].'</a>';
			if ($blogn_mod_poprank_ini["pv"] == "pvon") $blogn_mod_poprank_output .= ' ('.$blogn_mod_poprank_pop["count"].')';
			$blogn_mod_poprank_output .="</li>\n";
		} 
		$blogn_mod_poprank_output .= "</ol>\n"; 
	} else {
		$blogn_mod_poprank_output = '<div align="center">集計中</div>';
	}
	$blogn_skin = str_replace("{POPRANK}", $blogn_mod_poprank_output, $blogn_skin);
} else {
	return $blogn_skin;
}
?>