<?php
//--------------------------------------------------------------------
// *** Pop Rank ***
// LAST UPDATE: 2011/05/02
// Version    : 1.82
// Copyright  : nJOY
// http://i-njoy.net/
//--------------------------------------------------------------------
//
// control.php
//
//--------------------------------------------------------------------

$module_version = "1.82";

global $blogn_admin;
if (!$blogn_admin) exit;

$menu = array(1 => "ログ", "設定", "説明", "独自タグ", "インストール", "モジュール情報");
$loadtabs = "1";

require BLOGN_MODDIR."poprank/function.php";
$inifile = BLOGN_MODDIR."poprank/config.ini";
$ini = parse_ini_file($inifile);

switch($_POST["method"]) {
	case "view":
		$loadtabs = "1";
		break;
	case "edit":
		$ini["pv"]		= $_POST["pv"];
		$ini["rank"]	= $_POST["rank"];
		$ini["days"]	= $_POST["days"];
		$ini["author"]	= $_POST["author"];
		$ini["ip"]		= preg_replace("!/+!", "/", $_POST["ip"]);
		$ini["ip"]		= preg_replace("!/+$!", "", $ini["ip"]);
		if ($ini["author"] == "auon" && !$ini["ip"]) {
			$ini["ip"] = $_SERVER["REMOTE_ADDR"];
		}
		$fp = fopen($inifile, "w");
		foreach ($ini as $k => $i) {
			fwrite($fp, "$k=$i\r\n", 100);
		}
		fclose($fp);
		$message = "設定を変更しました。";
		$loadtabs = "2";
		break;
}

if ($ini["pv"] == "pvoff") $pv_off = ' checked="checked"';
if ($ini["pv"] == "pvon") $pv_on = ' checked="checked"';
if ($ini["author"] == "auoff") $ip_off = ' checked="checked"';
if ($ini["author"] == "auon") $ip_on = ' checked="checked"';

$day = array("", "", "", "", "", "", "", "");
if ($_POST["day"]) {
	$day[$_POST["day"]] = ' checked="checked"';
	$date = date("Ymd", blogn_mod_poprank_get_day($_POST["day"]));
} else {
	$day[0] = ' checked="checked"';
	$date = date("Ymd");
}

$logfile = BLOGN_MODDIR.'poprank/log/'.$date.'.log';
if (file_exists($logfile)) {
	$logs = @file($logfile);
	$number = count($logs);
	$data = @array_count_values($logs);
	@arsort($data);
	$data = @array_slice($data, 0, 20);
} else {
	$number = "0";
}

$hstfile = BLOGN_MODDIR.'poprank/log/month.cgi';
if (file_exists($hstfile) && filesize($hstfile)) {
	//@chmod($hstfile, 0777);
	$hst_count = count(@file($hstfile));
	$hsts = trim(file_get_contents($hstfile));
	$hst = explode("\n", $hsts );
	$max = max($hst); // 最大値
	$min = min($hst); // 最小値
	$ceil = ceil($max / 100) * 100; // Y軸最大値
	$avg = round (array_sum($hst) / $hst_count); // 平均値
	$avc = round($avg / $ceil, 2) * 100; // 平均値（%）
	$hst = array_reverse($hst);
	$plot = "";
	for ($j = 0; $j < $hst_count; $j++) {
		$mdata = $hst[$j];
		$plot .= "$mdata,";
	}
	$plot = substr($plot, 0, -1);
	$img = array("w" => 400, "h" => 150); // 画像サイズ（WxH）
	$firstday = date("Y/m/d",strtotime("-$hst_count day"));
	$yesterday = date("Y/m/d",strtotime("-1 day"));
}

$day_disp = substr($date, 0, 4).'/'.substr($date, 4, 2).'/'.substr($date, 6,2);

include BLOGN_MODDIR.$module_name.'/menu.php';

echo $js.'
<div class="blogn_main">

<div'.formatStyle($style["wrapper"]).'>
<h1'.formatStyle($style["mod_title"]).'>人気記事ランキング作成モジュール (ver'.$module_version.')</h1>

<!-- LEFT -->
<div'.formatStyle($style["coll"]).'>
<h2'.formatStyle($style["coll_h2"]).'>メニュー</h2>
<ul'.formatStyle($style["coll_ul"]).'>';

module_control_list($menu);

echo '
</ul>
<noscript><p'.formatStyle($style["nojs"]).'>※ Javascript 無効<br />メニュー内のテキストリンクは機能しないので、● をクリックしてナビゲートしてください。</p></noscript>
<p'.formatStyle($style["credit"]).'>Powered by<br /><a href="http://i-njoy.net/blog/" target="_blank"'.formatStyle($style["credit_a"]).'>nJOY BLOG</a></p>
</div>
 
<!-- RIGHT -->
<div'.formatStyle($style["colr"]).'>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("ログ", $menu).'">

<form method="post" action="./admin.php?mode=module&amp;action=edit">
<input type="hidden" name="blogn_module_name" value="'.$module_name.'" />
<input'.$day["7"].' type="radio" name="day" value="7" />1週間前
<input'.$day["6"].' type="radio" name="day" value="6" />6日前
<input'.$day["5"].' type="radio" name="day" value="5" />5日前
<input'.$day["4"].' type="radio" name="day" value="4" />4日前
<input'.$day["3"].' type="radio" name="day" value="3" />3日前
<input'.$day["2"].' type="radio" name="day" value="2" />一昨日
<input'.$day["1"].' type="radio" name="day" value="1" />昨日
<input'.$day["0"].' type="radio" name="day" value="0" />今日
<input type="hidden" name="method" value="view">
<input type="submit" value="変更">
</form>

<hr />

<div class="blogn_bar" style="font-size:100%;">'.$day_disp.'</div>
<table border="1" cellspacing="0" cellpadding="3" width="600">
<tr bgcolor="#dcdcdc"><td align="center"><strong>記事タイトル</strong></td><td align="center"><strong>PV</strong></td><td width="420"><strong>PV合計 = '.$number.'</strong></td>';

if (file_exists($logfile) && filesize($logfile)) {
	foreach($data as $key => $value){
		$key = rtrim($key);
		$percentage = ($value / $number * 100);
		$length = round($percentage * 20);
		if ($length > 400) {
			$length = 410;
			$bar = 'module/poprank/log/bar_r.gif';
		} else {
			$bar = 'module/poprank/log/bar_b.gif';
		}
		$log = blogn_mod_db_log_load_for_editor($key);
		if ($log[0]) {
			$title = str_replace("&#44;", ",", $log[1]["title"]);
			if (!$title) {
				$short_title = "無題 (".blogn_mod_poprank_convert_date($log[1]["date"]).")";
			} elseif (strlen($title) > 30) {
				$short_title = blogn_mbtrim($title, 28);
				$short_title .= "...";
			} else {
				$short_title = $title;
			}
			echo '
<tr><td><a href="'.BLOGN_HOMELINK.'index.php?e='.$key.'" target="_blank" title="['.$key.'] '.$title.'">'.$short_title.'</a></td><td align="center">'.$value.'</td><td style="padding:0;background-image:url(module/poprank/log/ruler.gif);"><img src="'.$bar.'" alt="" width="'.$length.'" height="10" title="'.number_format($percentage, 1).'%"></td>';
		}
	}
} else {
	echo '<tr><td colspan="3">ログはありません。</td></tr>';
}

echo '</table>
<hr />';

if ($hst_count > 1) {
	echo '<p>'.$firstday.' ～ '.$yesterday.' の PV の推移（最高: '.$max.', 最低: '.$min.', 平均: '.$avg.'）</p>
<img src="http://chart.apis.google.com/chart?chs='.$img["w"].'x'.$img["h"].'&amp;chd=t:'.$avg.','.$avg.'|'.$plot.'&amp;cht=lc&amp;chds=0,'.$ceil.'&amp;chco=0000ff,ff0000&amp;chxt=y,x&amp;chxl=0:|0|'.urlencode("平均").'|'.$ceil.'|1:|'.$hst_count.urlencode("日前").'|'.urlencode("昨日").'&amp;chxp=0,0,'.$avc.',100|1,5,97&amp;chls=1,1,0|3,1,0&amp;chg=0,20,2,5&amp;chf=c,s,efefef" width="'.$img["w"].'" height="'.$img["h"].'" style="margin:1em;">';
} else {
	echo '<p>PV の推移: データ集計中</p>';
}

echo '
<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("設定", $menu).'">

<form method="post" action="./admin.php?mode=module&amp;action=edit">
<input type="hidden" name="blogn_module_name" value="'.$module_name.'">

<div class="blogn_bar">現在の設定</div>
<table border="1" cellspacing="0" cellpadding="3" width="600">
<tr>
<td bgcolor="#dcdcdc"><strong>集計期間</strong></td>
<td><select name="days">';

for ($i = 1; $i < 8; $i++) {
	if ( $ini["days"] == $i ) {
		echo '<option value="'.$i.'" selected="selected">'.$i.'日間</option>';
	}else{
		echo '<option value="'.$i.'">'.$i.'日間</option>';
	}
}
echo '
</select> のPV数をもとにランキングを割り出す（ランキングには24時以降に反映されます）</td>
</tr>

<tr>
<td bgcolor="#dcdcdc"><strong>ランキング</strong></td>
<td><select name="rank">';

for ($i = 1; $i < 21; $i++) {
	if ( $ini["rank"] == $i ) {
		echo '<option value="'.$i.'" selected="selected">Top '.$i.'</option>';
	}else{
		echo '<option value="'.$i.'">Top '.$i.'</option>';
	}
}
echo '
</select> まで表示</td>
</tr>

<tr><td bgcolor="#dcdcdc"><strong>PV数の表示</strong></td>
<td>
<input type="radio" name="pv" value="pvon"'.$pv_on.'>表示する<br />
<input type="radio" name="pv" value="pvoff"'.$pv_off.'>表示しない<br />
</td></tr>

<tr><td bgcolor="#dcdcdc"><strong>管理人の除外機能</strong></td>
<td>
<input type="radio" name="author" value="auoff"'.$ip_off.'>管理人のアクセスも記録する<br />
<input type="radio" name="author" value="auon"'.$ip_on.'>管理人のアクセスは記録しない（「除外IPアドレス」欄記入必須 <span'.formatStyle($style["red"]).'>*</span>）<br />
</td></tr>

<tr><td bgcolor="#dcdcdc"><strong>除外IPアドレス <span'.formatStyle($style["red"]).'>*</span></strong></td>
<td>
<input type="text" name="ip" value="'.$ini["ip"].'" size="80" style="ime-mode: disabled;" />
</td></tr>
</table>

<input type="hidden" name="method" value="edit">
<input type="submit" value="変更"'.formatStyle($style["button"]).'>
<span'.formatStyle($style["message"]).'>'.$message.'</span>

</form>

<div'.formatStyle($style["mod"]).'>
<h2'.formatStyle($style["mod_h2"]).'>管理人の除外機能について</h2>
<ul'.formatStyle($style["mod_list"]).'>
<li>「除外IPアドレス」欄に入力したIPアドレスからのアクセスをカウントしないように出来ます。</li>
<li>半角スラッシュ (/) で区切って複数のIPアドレスを指定することが出来ます。</li>
<li>IPアドレスの範囲を指定したい時は、半角ピリオド単位で区切ってください。<br />
「 192.168.0. 」で 192.168.0.0～192.168.0.255 までのIPを指定することになります。<br />
「 192.168. 」だと 192.168.0.0～192.168.255.255 までのIPを指定することになります。</li>
</ul>

<p'.formatStyle($style["mod_p"]).'><span'.formatStyle($style["red"]).'>■</span> 現時点のあなたのIPアドレスは <input type="text" value="'.$_SERVER["REMOTE_ADDR"].'" size="18" /> です。</p>
</div>

<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("説明", $menu).'">
<div class="blogn_bar">説明</div>
<div'.formatStyle($style["mod"]).'>

<h2'.formatStyle($style["mod_h2"]).'>ログについて</h2>

<ul'.formatStyle($style["mod_list"]).'>
<li>人気記事上位20位までを表示します。</li>
<li>記事タイトル上にカーソルをのせると、記事IDとタイトルがポップアップで表示されます。</li>
<li>20% を超えている場合、グラフは赤で表示されます。</li>
<li>グラフの上にカーソルをのせると、その記事の PV が全 PV に対して占める割合が表示されます。</li>
</ul>


</div>
<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("独自タグ", $menu).'">
<div class="blogn_bar">独自タグ</div>
<div'.formatStyle($style["mod"]).'>

<h2'.formatStyle($style["mod_h2"]).'>このモジュールで使える独自タグ</h2>

<table border="1" cellspacing="0" cellpadding="3" width="500"'.formatStyle($style["mod_table"]).'>
<tr bgcolor="#dcdcdc"><th width="100">独自タグ</th><th>説明</th><th width="50">補足</th></tr>
<tr><td>{POPRANK}</td><td>人気記事ランキングを表示</td><td>-</td></tr>
</table>

<h2'.formatStyle($style["mod_h2"]).'>このモジュールで出力するスタイルシート用 id 属性</h2>

<table border="1" cellspacing="0" cellpadding="3" width="500"'.formatStyle($style["mod_table"]).'>
<tr bgcolor="#dcdcdc"><th width="100">id 属性</th><th>説明</th><th width="50">HTML</th><th width="50">補足</th></tr>
<tr><td>poprank</td><td>ランキング番号順リスト</td><td>ol</td><td>-</td></tr>
</table>

</div>
<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("インストール", $menu).'">
<div class="blogn_bar">インストール</div>
<div'.formatStyle($style["mod"]).'>

<h2'.formatStyle($style["mod_h2"]).'>インストール方法</h2>
<ol'.formatStyle($style["mod_list"]).'>
<li>「config.ini」のパーミッションを「666」等に変更する。</li>
<li>/log/ ディレクトリのパーミッションを「777」等に変更する。</li>
<li>（オプション）スキンの HTML ファイルに独自タグを追加する。</li>
'.$mod_control["co_start"].'<li>PV カウントのためには、モジュール管理画面から動作スイッチを ON にする必要があります。</li>'.$mod_control["co_end"].'
</ol>

</div>

<hr'.formatStyle($style["hr"]).' />
</div>

<!-- Start Tabcontent -->
<div id="tabcontent'.array_search("モジュール情報", $menu).'">
<div class="blogn_bar">モジュール情報</div>
<div'.formatStyle($style["mod"]).'>

<h2'.formatStyle($style["mod_h2"]).'>公式サイト</h2>
<p'.formatStyle($style["mod_p"]).'>もっと詳しい情報や最新版モジュールのダウンロードは「<a href="http://i-njoy.net/tips/plus_pop.shtml" target="_blank">人気記事ランキング作成モジュール</a>」の解説ページからどうぞ。</p>
<p'.formatStyle($style["mod_p"]).'>最新情報は「<a href="http://i-njoy.net/blog/" target="_blank">nJOY BLOG</a>」から入手できます。</p>

<h2'.formatStyle($style["mod_h2"]).'>モジュール構成ファイル</h2>
<ul'.formatStyle($style["package"]).'>
<li'.formatStyle($style["pack_0"]).'>+ blognplus /</li>
<li'.formatStyle($style["pack_1"]).'>+ module /</li>
<li'.formatStyle($style["pack_2"]).'>+ poprank /</li>
<li'.formatStyle($style["pack_3"]).'>- blank.php</li>
<li'.formatStyle($style["pack_3"]).'>- <span'.formatStyle($style["red"]).'>config.cgi</span></li>
<li'.formatStyle($style["pack_3"]).'>- control.php</li>
<li'.formatStyle($style["pack_3"]).'>- function.php</li>
<li'.formatStyle($style["pack_3"]).'>- index.html</li>
<li'.formatStyle($style["pack_3"]).'>- info.php</li>
<li'.formatStyle($style["pack_3"]).'>- install.php</li>
<li'.formatStyle($style["pack_3"]).'>- menu.php</li>
<li'.formatStyle($style["pack_3"]).'>- poprank.php</li>
<li'.formatStyle($style["pack_3"]).'>- style.php</li>
<li'.formatStyle($style["pack_3"]).'>- uninstall.php</li>
<li'.formatStyle($style["pack_3"]).'>- update.php</li>
<li'.formatStyle($style["pack_3"]).'>+ <span'.formatStyle($style["blue"]).'>log</span> /</li>
<li'.formatStyle($style["pack_4"]).'>- bar_b.gif</li>
<li'.formatStyle($style["pack_4"]).'>- bar_r.gif</li>
<li'.formatStyle($style["pack_4"]).'>- ruler.gif</li>
</ul>

<p'.formatStyle($style["mod_p"]).'><span'.formatStyle($style["red"]).'>赤文字のファイル</span>のパーミッションは「666」や「606」に変更してください。<br /><span'.formatStyle($style["blue"]).'>/log/</span> ディレクトリのパーミッションは「777」や「707」に変更してください。</p>

'.$mod_control["co_start"].'
<h2'.formatStyle($style["mod_h2"]).'>動作 ON/OFF</h2>
<p'.formatStyle($style["mod_p"]).'>モジュールをインストール後に、動作のオン・オフを切り替える必要があります。</p>
<dl'.formatStyle($style["mod_dl"]).'>
<dt>PC</dt><dd>PC の PV をカウント、またはPC 用スキンに独自タグを記述した場合、「PC」欄を <img src="images/on.gif" width="20" height="20" alt="ON" /> にしてください。</dd>
<dt>携帯</dt><dd>携帯の PV をカウント、または携帯用スキンに独自タグを記述した場合、「携帯」欄 を <img src="images/on.gif" width="20" height="20" alt="ON" /> にしてください。</dd>
</dl>

<h2'.formatStyle($style["mod_h2"]).'>優先順位</h2>
<p'.formatStyle($style["mod_p"]).'>特に制限はありません。</p>
'.$mod_control["co_end"].'

</div>
<hr'.formatStyle($style["hr"]).' />
</div>


</div>
</div>
</div>';

?>
